List users
GET/nevisidm/api/scim/v1/:clientExtId/Users
Returns a paginated list of SCIM user representations belonging to the specified client. Supports filtering, sorting, attribute selection, and bulk export format.
Specific credential types can be selected using credentials[TYPE] syntax in the attributes/excludedAttributes parameters, e.g. credentials[PASSWORD] or credentials[OTP]. Only the specified credential types will be included in or excluded from the response.
When bulkImportFormat is set to true, the response is a ScimBulkRequest with POST operations instead of the standard ScimListResponse.
Request
Path Parameters
Client's external identifier.
Query Parameters
Start index for the listing. Default value: 1.
Maximum number of elements in the result list. Default value is 10 and maximum set by application.scim.filter-max-results.
Comma separated list of attributes must be contained by the result. Empty value means all available attributes are contained by the result.
Comma separated list of attributes must NOT be contained by the result. Empty value means all available attributes are contained by the result. If attributes present and not empty, this 'excludedAttributes' is ignored.
Filter expression may be used to restrict results to one or more specific resource. Empty filter means all possible resources are selected.
Name of an attribute (or sub-attribute) for sorting the result. Empty value means as sorting attribute the 'id' is used to. When used together with 'filter', deterministic output is not guaranteed because filtering and sorting are processed on separate execution branches.
Possible values: [ascending, descending]
Sort order of selected attribute (in 'sortBy' parameter). Empty value means the default ascending sorting order.
The output is ScimBulkRequest with create operations instead of ScimListResponse as standard defines. This optional parameter by default false.
Responses
- 200
- 400
Users retrieved successfully
- application/json
- Schema
- Example (from schema)
- User list
- Schemas endpoint
- ResourceTypes endpoint
- Bulk export format with users list
Schema
- Array [
- ]
An array of Strings containing URIs that are used to indicate the namespaces of the SCIM schemas that define the attributes present in the current JSON structure.
Number of total results.
Number of results in a single response. By default 10. Controlled by 'count' request parameter.
Start index of current result. By default 1. Controlled by 'startIndex' request parameter.
Resources ScimBase[]required
Array of SCIM resources. For example array of users.
An array of Strings containing URIs that are used to indicate the namespaces of the SCIM schemas that define the attributes present in the current JSON structure.
{
"schemas": [
"urn:ietf:params:scim:schemas:core:2.0:User"
],
"totalResults": 100,
"itemsPerPage": 10,
"startIndex": 1,
"Resources": [
{
"schemas": [
"urn:ietf:params:scim:schemas:core:2.0:User"
],
"id": "100",
"userName": "[email protected]"
},
{}
]
}
{
"schemas": ["urn:ietf:params:scim:api:messages:2.0:ListResponse"],
"totalResults": 2,
"itemsPerPage": 10,
"startIndex": 1,
"Resources": [
{
"schemas": ["urn:ietf:params:scim:schemas:core:2.0:User"],
"id": "123456",
"externalId": "user-123",
"userName": "jdoe",
"name": {
"formatted": "John Doe",
"familyName": "Doe",
"givenName": "John"
},
"displayName": "John Doe",
"active": true,
"emails": [{"value": "[email protected]"}],
"meta": {
"resourceType": "User",
"created": "2024-01-15T10:30:00",
"lastModified": "2024-01-15T10:30:00",
"location": "https://idm.example.com/nevisidm/api/scim/v1/100/Users/100-1001"
}
}
]
}
{
"schemas": ["urn:ietf:params:scim:api:messages:2.0:ListResponse"],
"totalResults": 2,
"itemsPerPage": 10,
"startIndex": 1,
"Resources": [
{
"schemas": ["urn:ietf:params:scim:schemas:core:2.0:Schema"],
"id": "urn:ietf:params:scim:schemas:core:2.0:User",
"name": "User",
"description": "SCIM provides a resource type for User resources.",
"attributes": [
{
"name": "userName",
"type": "string",
"multiValued": false,
"description": "Unique identifier for the User.",
"required": false,
"caseExact": true,
"mutability": "readWrite",
"returned": "default",
"uniqueness": "none"
},
{
"name": "name",
"type": "complex",
"subAttributes": [
{
"name": "familyName",
"type": "string",
"multiValued": false,
"required": false,
"caseExact": true,
"mutability": "readWrite",
"returned": "default",
"uniqueness": "none"
}
]
}
]
}
]
}
{
"schemas": ["urn:ietf:params:scim:api:messages:2.0:ListResponse"],
"totalResults": 1,
"itemsPerPage": 10,
"startIndex": 1,
"Resources": [
{
"schemas": ["urn:ietf:params:scim:schemas:core:2.0:ResourceType"],
"id": "User",
"name": "User",
"description": "SCIM provides a resource type for User resources.",
"meta": {
"resourceType": "ResourceType",
"location": "https://idm.example.com/nevisidm/api/scim/v1/ResourceTypes/User"
},
"endpoint": "/{clientExtId}/Users",
"schema": "urn:ietf:params:scim:schemas:core:2.0:User",
"schemaExtensions": [
{
"required": true,
"schema": "urn:nevis:idm:scim:schemas:v1:extension:User"
}
]
}
]
}
{
"schemas": ["urn:ietf:params:scim:api:messages:2.0:BulkRequest"],
"failOnErrors": 10,
"Operations": [
{
"method": "POST",
"path": "Users",
"data": {
"schemas": [
"urn:ietf:params:scim:schemas:core:2.0:User",
"urn:nevis:idm:scim:schemas:v1:extension:User"
],
"userName": "jdoe"
}
},
{
"method": "POST",
"path": "Users",
"data": {
"schemas": [
"urn:ietf:params:scim:schemas:core:2.0:User",
"urn:nevis:idm:scim:schemas:v1:extension:User"
],
"userName": "jdoe2"
}
}
]
}
Invalid SCIM request
- application/json
- Schema
- Example (from schema)
- Count exceeds maximum
- Invalid pagination parameters
- Invalid filter attribute
- Filter parse error
Schema
An array of Strings containing URIs that are used to indicate the namespaces of the SCIM schemas that define the attributes present in the current JSON structure.
status HttpStatusCoderequired
The HTTP status code.
Possible values: [invalidFilter, tooMany, uniqueness, mutability, invalidSyntax, invalidPath, noTarget, invalidValue, invalidVers, sensitive]
A SCIM detail error keyword.
A detailed human-readable message.
{
"schemas": [
"urn:ietf:params:scim:schemas:core:2.0:User"
],
"status": 400,
"scimType": "invalidValue",
"detail": "The requested user '999' does not exist in IDM database."
}
{
"schemas": ["urn:ietf:params:scim:api:messages:2.0:Error"],
"status": "BAD_REQUEST",
"scimType": "invalidValue",
"detail": "Count is higher than allowed (100)"
}
{
"schemas": ["urn:ietf:params:scim:api:messages:2.0:Error"],
"status": "BAD_REQUEST",
"scimType": "invalidValue",
"detail": "Start index must be positive"
}
{
"schemas": ["urn:ietf:params:scim:api:messages:2.0:Error"],
"status": "BAD_REQUEST",
"scimType": "invalidValue",
"detail": "Filter attribute 'invalidAttr' is not valid or unsupported or encrypted."
}
{
"schemas": ["urn:ietf:params:scim:api:messages:2.0:Error"],
"status": "BAD_REQUEST",
"scimType": "invalidValue",
"detail": "Filter expression cannot be parsed. Message: Missing expected character '@' at '9' in 'userName @'"
}